#include "MasterSysMonInfo.h"

MasterSysMonInfo::MasterSysMonInfo() {
	cout << "MasterSysMonInfo()\n";
}

bool MasterSysMonInfo::InBounds(int InfoIndex) const {
	if (InfoIndex >= 0 && InfoIndex < numberInfos)
		return true;
	cout << "Error in MasterSysMonInfo: Out of bounds access\n";
	cout << "while trying to access one of these plugins:\n";
	for (int x=0; x<numberInfos; ++x) {
		cout << theInfo[x].name << "  ";
	}
	cout << endl;
	return false;
}

string &MasterSysMonInfo::Name(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].name;
}
		
string &MasterSysMonInfo::Category(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].category;
}

string &MasterSysMonInfo::Units(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].units;
}

bool  MasterSysMonInfo::HasTopValue(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].hasTopValue;
}

bool  MasterSysMonInfo::HasBottomValue(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].hasBottomValue;
}

float MasterSysMonInfo::TopValue(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].topValue;
}

float MasterSysMonInfo::BottomValue(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].bottomValue;
}

float MasterSysMonInfo::DefaultInterVal(int InfoIndex) const {
	assert(InBounds(InfoIndex));
	return theInfo[InfoIndex].defaultInterval;
}

int   MasterSysMonInfo::NumberOfInfos() const {
	return numberInfos;
}

string numtostr(int n) {
	char temp[80];
	sprintf(temp, "%d", n);
	return string(temp);
}
