// MasterSysMonInfo.h
// Contains the base class for each add-on for System Monitor
// Inherit from this class

#ifndef __MASTERSYSMONINFO_H
#define __MASTERSYSMONINFO_H

#include <iostream>
#include <string>
#include <be/support/String.h>
#include <cstdio>
#include "assert.h"
using namespace std;

class MasterSysMonInfo;

typedef struct SysMonInfo {
	string name;
	string category;
	string units;
	bool hasTopValue;
	bool hasBottomValue;
	float topValue;
	float bottomValue;
	float defaultInterval;
};

class MasterSysMonInfo {
public:
	// Constructor
	MasterSysMonInfo();
	// Destructor
//	virtual ~MasterSysMonInfo();
		
	// Inspectors
	string &Name(int NumberInfo) const;
	string &Category(int NumberInfo) const;
	string &Units(int NumberInfo) const;
	bool HasTopValue(int NumberInfo) const;
	bool HasBottomValue(int NumberInfo) const;
	float TopValue(int NumberInfo) const;
	float BottomValue(int NumberInfo) const;
	float DefaultInterVal(int NumberInfo) const;
	virtual float GetValue(int NumberInfo) = 0;
	int NumberOfInfos() const;
protected:
	bool InBounds(int InfoIndex) const;
	int numberInfos;
	SysMonInfo *theInfo;
};

// Function that converts a number to a string
string numtostr(int n);

#endif