#include "lm78.h"

ASysMonInfo::ASysMonInfo() : MasterSysMonInfo() {
	get_system_info(&sysInfo);
	// VoltVTT, VoltVIO, VoltP5, VoltP12, VoltM12, VoltM5, Volt5VSB
	// VoltCore[0,1], TempCPU[0,1,2], FanCPU[0,1,2]
	// Create a max sized array, big enough to hold each possible one
	numberInfos = 15;
	
	theInfo = new SysMonInfo[numberInfos];
	//lm78 = Mlm78();
	if (lm78.InitCheck() != B_OK) {
		cout << "Error: could not init lm78 driver!!!\n";
		numberInfos = 0;
		return;
	}

	lm78.Update();
	
	// check which fan is on
//	for (int x=0; x<3; ++x) {
//		if (lm78.FanCPU[x] != -1) {
//			numberInfos++;

//	if (sysInfo.cpu_count == 2) {
//		numberInfos += 4; // twice VoltCore and TempCPU
//	}
//	else if (sysInfo.cpu_count == 1) {
//		numberInfos += 2; // VoltCore and TempCPU
//	}
//	else {
//		cout << "What kind of motherboard is this?\n";
//	}	
	
		
	char *tempPtrString;

	for (int x=0; x<numberInfos; ++x) {
		// Set names
		tempPtrString = new char[strlen(names[x]) + 1];
		strcpy(tempPtrString, names[x]);
		theInfo[x].name = tempPtrString;
		tempPtrString = NULL;

		// Set categories
		tempPtrString = new char[strlen("lm78") + 1];
		strcpy(tempPtrString, "lm78");
		theInfo[x].category = tempPtrString;
		tempPtrString = NULL;

		// Set units
		tempPtrString = new char[strlen("blahs") + 1];
		strcpy(tempPtrString, "blahs");
		theInfo[x].units = tempPtrString;
		tempPtrString = NULL;
		
		theInfo[x].topValue = 60.0f;
		
	}
}

float ASysMonInfo::GetValue(int NumberInfo) {
	lm78.Update();
	switch (NumberInfo) {
	case 0: return lm78.VoltVTT;
		break;
	case 1: return lm78.VoltVIO;
		break;
	case 9: return lm78.TempCPU[0];
		break;
	case 10: return lm78.TempCPU[1];
		break;
	case 11: return lm78.TempCPU[2];
		break;
	}
}

ASysMonInfo::~ASysMonInfo() {
	cout << "~ASysMonInfo()\n";
	delete [] theInfo;
}

ASysMonInfo blah;

MasterSysMonInfo* GetInfoClass() {
	return &blah;
}